<template>
  <div class="myanmarLatinCard card">
    <!--"easter egg": any non myanmar unicode will be transliterated with https://www.npmjs.com/package/transliteration -->
    <div class="relative flex flex-col flex-1">
      <input
        ref="myanmarInput"
        class="flex-1"
        name="dream"
        aria-label="myanmarToRomanize"
        type="text"
        maxlength="128"
        placeholder="Write Unicode Myanmar text here"
        @keyup="pronounce"
        autocomplete="off"
      />
    </div>
    <div class="flex flex-shrink flex-col bg-yellow-600">
      <div class="flex flex-1">
        <div
          class="flex-shrink sourceText text-center"
          title="Stacked Character expansion. Literal transliteration"
        >
          Written
        </div>
        <div
          class="flex-shrink romanizedText text-center"
          title="number weakening with Classifier. Voiced Consonant after Vowel and n/ng. Without known compound words (nouns/vowels)"
        >
          Spoken
        </div>
        <div
          class="flex-1 romanizedText sandhi text-center"
          title="HalfVowel/Minor Syllable/Nasal Consonant and known compound words (nouns/vowel)"
        >
          Spoken Experimental (Sandhi)
        </div>
        <select v-model="transliterationType" @change="pronounce">
          <option>{{ TypeEnums.BGN }}</option>
          <option>{{ TypeEnums.MLCTS }}</option>
          <option>{{ TypeEnums.IPA }}</option>
          <option>{{ TypeEnums.Okell }}</option>
        </select>
        <!--<div class="btnContainer flex">
                <button
                  type="submit"
                  id="submit-dream"
                  class="btnRomanize flex-1"
                  @click="pronounce"
                >
                  Romanize written unicode text
                </button>
              </div>-->
      </div>
      <div class="flex flex-1 flex-col" v-if="lastWritten">
        <div class="flex-1 sourceText">{{ lastWritten }}</div>
        <div class="flex-1 romanizedText">
          {{ lastSpoken }}
        </div>
        <div class="flex-1 romanizedText sandhi">
          {{ lastSpokenSandhi }}
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mypron } from "./../assets/js/my-pron";
import _ from "lodash";

function workerObject() {
  //postMessage("Worker is ready...");

  onmessage = function(e) {
    //importScripts('./../assets/js/my-pron.js');

    if (typeof e.data == "string") {
    } else {
      props = e.data; // JSON.parse (e.data);
      var url = props[4];
      var index = url.indexOf("index.html");
      if (index != -1) {
        url = url.substring(0, index);
      }
      console.log(url);
      //   importScripts(url+'my-pron.js');
      if (e.data === "start") {
        //simulate heavy work..
        var max = 500000000;
        for (var i = 0; i < max; i++) {
          if (i % 100000 === 0)
            postMessage("Progress: " + ((i / max) * 100).toFixed(0) + "%");
        }
        postMessage("Done!");

        //postMessage(myPron(e.data))
      }
      //if(e.data instanceof object)
      postMessage("testbefore mypron");
      console.log(props[0]);

      //  let pron = mypron(props[0], props[1], props[2], props[3]);
      // console.log(pron)
      postMessage("test");
      if (e.data === "close") {
      }
    }
  };
}

export default {
  name: "transliteration-box",
  data() {
    // data: function() {
    return {
      klaroManager: null,
      expireDateInMS: 1,
      daysInMs: 86400000, //24 * 60 * 60 * 1000,
      storedType: null,
      userSelected: "",
      TypeEnums: {
        BGN: "BGN",
        IPA: "IPA",
        MLCTS: "MLCTS",
        Okell: "Okell",
      },
      inprocessing: "",
      myPronFunc:null,
      lastInput: "",
      lastTypeSelection: "",
      lastWritten: "",
      lastSpoken: "",
      lastSpokenSandhi: "",
      transliterations: [
        /*
        { source: "စကြဝဠ ", target: "result" },
        { source: "လိမ္မော်ရည်  2", target: "result2" },*/
      ],
      transliterationType: "BGN",
      spoken: true,
      fetchState: "",
      lastSubmit: 0,
      myWorker: null,
      workerTest: null,
    };
  },
  mounted() {
    this.klaroManager = klaro.getManager();
    this.expireDate =
      this.klaroManager["config"]["cookieExpiresAfterDays"] * this.daysInMs;
    this.updatePersistentType();
    this.myPronFunc = mypron;
    console.log(mypron)
    console.log(this.myPronFunc)

    let entire = workerObject.toString();
    let body = entire.slice(entire.indexOf("{") + 1, entire.lastIndexOf("}"));
    /*
    alternative https://stackoverflow.com/questions/10343913/how-to-create-a-web-worker-from-a-string
    var dataObj = '(' + workerFunction + ')();'; // here is the trick to convert the above fucntion to string
    var blob = new Blob([dataObj.replace('"use strict";', '')]); // firefox adds "use strict"; to any function which might block worker execution so knock it off

    var blobURL = (window.URL ? URL : webkitURL).createObjectURL(blob, {
      type: 'application/javascript; charset=utf-8'
      });
    */
    //console.log(body);
    let thisObject = this;
    // this.workerTest = this.createWorker(body);

    //console.log(this.workerTest)
    //this.workerTest.postMessage("start");
    //console.log(this.workerTest);

    // this.useWorker();
    /*
    this.useWorker([
      "ပိဿာ",
      this.transliterationType,
      true,
      false,
      document.location.href
    ]);
    */
    //https://stackoverflow.com/questions/21625419/is-it-possible-to-terminate-a-running-web-worker
    //still running in background?
    // this.workerTest = this.createWorker(body);
    //this.workerTest.onmessage = function(e){thisObject.workerLog(e)}//{content:"test",content2:"prop2"}
    // this.workerTest.postMessage('start');
  },
  methods: {
    async useWorker(data) {
      this.workerTest.terminate(); //worker deleted? needs new createWorker
      let entire = workerObject.toString();
      let body = entire.slice(entire.indexOf("{") + 1, entire.lastIndexOf("}"));
      let thisObject = this;
      this.workerTest = this.createWorker(body);
      this.workerTest.onmessage = function(e) {
        thisObject.workerLog(e);
      }; //{content:"test",content2:"prop2"}
      //this.workerTest.postMessage("start");

      this.workerTest.postMessage(data);
      // console.log(this.workerTest);
    },
    createWorker(body) {
      let blob = new Blob([body], { type: "text\/plain" }); //{type:"module"}
      return new Worker(URL.createObjectURL(blob));
    },
    workerLog(e) {
      console.log(e.data);
    },
    setWithExpiry(key, value, ttl) {
      const now = new Date();

      // `item` is an object which contains the original value
      // as well as the time when it's supposed to expire
      const item = {
        value: value,
        expiry: now.getTime() + ttl,
      };
      localStorage.setItem(key, JSON.stringify(item));
    },
    getWithExpiry(key) {
      const itemStr = localStorage.getItem(key);
      // if the item doesn't exist, return null
      if (!itemStr) {
        return null;
      }
      const item = JSON.parse(itemStr);
      const now = new Date();
      // compare the expiry time of the item with the current time
      if (now.getTime() > item.expiry) {
        // If the item is expired, delete the item from storage
        // and return null
        localStorage.removeItem(key);
        return null;
      }
      return item.value;
    },
    updatePersistentType(selectedType) {
      const DEBUG = false;
      const hasConsent = this.klaroManager.consents["myanmarToLatinType"];
      DEBUG && console.log("consents myanmarToLatinType: " + hasConsent);
      const storedType = this.getWithExpiry("typeEnum"); //localStorage.typeEnum;
      if (hasConsent) {
        DEBUG && console.log("localStorage.typeEnum: " + storedType);

        if (selectedType) {
          DEBUG && console.log("selectedType: " + selectedType);
          // localStorage.typeEnum = selectedType;
          this.setWithExpiry("typeEnum", selectedType, this.expireDate);
        } else {
          if (!storedType) {
            //localStorage.typeEnum = this.TypeEnums.BGN;
            this.setWithExpiry("typeEnum", this.TypeEnums.BGN, this.expireDate);
          } else {
            this.transliterationType = storedType;
          }
        }
      } else {
        DEBUG && console.log("localStorage.typeEnum: " + storedType);
        if (storedType) localStorage.removeItem("typeEnum");
      }
    },
    changeStateContent(text) {
      this.fetchState = text;
    },
    async updatePron(inputValue) {
      // if (this.inprocessing == "")
      {
       // this.inprocessing = inputValue;
       console.log(this.myPronFunc)
       this.myPronFunc = mypron;
        this.lastWritten = await this.myPronFunc(
          inputValue,
          this.transliterationType,
          false,
          false
        );
        this.lastSpoken = await this.myPronFunc(
          inputValue,
          this.transliterationType,
          true,
          false
        );
        this.lastSpokenSandhi = await this.myPronFunc(
          inputValue,
          this.transliterationType,
          true,
          true
        );
        //  this.inprocessing = "";
      }
    },
    pronounce: _.debounce(async function(text) {
      const DEBUG = false;
      //console.log("pronounce")
      //console.log("this.$refs.myanmarInput: " );
      // console.log(event);
      if (typeof text == "string") this.$refs.myanmarInput.value = text;
      const inputValue = this.$refs.myanmarInput.value.trim();
      const maxLength = 128;
      const changedType =
        this.lastTypeSelection == "" ||
        this.lastTypeSelection != this.transliterationType;

      //console.log(this.transliterationType)
      if (changedType) {
        this.updatePersistentType(this.transliterationType);
        this.lastTypeSelection = this.transliterationType;
      }

      if (inputValue.length < maxLength) {
        if (this.lastInput != inputValue || changedType) {
          await this.updatePron(inputValue);
          this.lastInput = inputValue;
        }
      } else {
        const limitText =
          "Text length limitation exceeded. This page is only for transliterating short words and sentences.";
        this.lastWritten = limitText;
        this.lastSpoken = "";
        this.lastSpokenSandhi = "";
      }

      //this.$refs.myanmarInput.value = "";
      // this.$refs.myanmarInput.focus();
    }, 1000),
  },
};
</script>

<style>
.myanmarLatinCard {
  top: 40px;
  @apply sticky z-10 border;
}
.sourceText {
  @apply px-2 py-1 bg-yellow-600 border;
}
.romanizedText {
  background-color: #ccffcc;
  @apply px-2 py-1 border border-dotted border-green-800;
}
.sandhi {
  background-color: #ddff55;
}

@media screen and (max-width: 840px) {
  .myanmarLatinCard {
    top: 0px;
  }
  form {
    @apply flex-col;
  }
  .btnRomanize {
  }
}
</style>
